clear all
clc

x=5;

% CANCELLAZIONE NUMERICA

for i=1:18
    a(i)=10^(-i);
    y=5-a(i);
    err_rel(i) = abs((x-y)-a(i))/abs(a(i));
    err(i)=100*abs(x-y-a(i))/a(i);
end

tabella=[a' err_rel' err']
semilogx(a,err)

% ASSOCIATIVITA'

for i=1:18
    a(i)=10^(-i);
    y=5-a(i);
    if ((1+a(i))-1)==(1+(a(i)-1))
        ass(i)=1;
    else
        ass(i)=0;
    end
end

tabella=[tabella ass']
    
% Nellaritmetica floating point valgono solo alcune delle propriet delle operazioni elementari. 
% Per laritmetica di macchina in generale non valgono le seguenti propriet, valide invece 
% nellaritmetica esatta
% Possiamo pertanto concludere che espressioni che sono equivalenti in aritmetica esatta non 
% risultano generalmente tali nellaritmetica di macchina. 
% Malgrado ci, due espressioni (non nulle) saranno definite equivalenti dal punto di vista del 
% calcolo numerico quando, calcolate con un computer, forniscono risultati che differiscono per una 
% tolleranza relativa dellordine della precisione di macchina.
